#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>

/* Velicna bafera koji se koristi */
#define BUFF_SIZE 1024

/* Funkcija ispisuje primljenu poruku kao i string koji opisuje nastali problem.
   Potom prekida izvrsavanje programa. */
void error_fatal (char *message){
  perror (message);
  exit (1);
}

/* Program prepisuje ulaz na izlaz, koristeci read i write sistemske pozive */
int main(){
  int read_chars;
  char buffer[BUFF_SIZE];

  /* Sve dok se ucita vise od 0 karaktera, ucitani karatkeri se ispisuje na standardni izlaz.
     Ukoliko je broj ispisanih karaktera manji od broja ucitanih, doslo je do greske pri pisanju. */
  while ( (read_chars = read (STDIN_FILENO, buffer, sizeof (buffer))) > 0)
    if (write (STDOUT_FILENO, buffer, read_chars) != read_chars)
      error_fatal ("write error");

  /* Ako je funkcija read vratila -1, znaci da je doslo do greske pri citanju. */
  if (read_chars < 0)
    error_fatal ("read error");

  return 0;
}
