#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

/* Funkcija ispisuje primljenu poruku kao i string koji opisuje nastali problem.
   Potom prekida izvrsavanje programa. */
void error_fatal (char *message){
  perror (message);
  exit (1);
}

int main(){
  char buffer1[] = "abcdefgh";
  char buffer2[] = "ABCDEFGH";
  int fd;

  /* Najpotpuniji ispis o greski je kada se navede i kom fajlu (u kom programu) je doslo do greske.
     U nasim primerima postoji najcesce jedan program, pa ce se ime programa cesto zanemarivati. */
  /* Otvara se fajl a ako ne postoji kreira sa odgovarajucim pravima (o tome vise price kasnije). 
     Ukoliko fajl vec postoji njegova duzina se smanjuje na 0. */
  if ( (fd = open ("file.hole", O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)) < 0)
    error_fatal ("open error in hole.c");

  /* Upisuje se poruka iz prvog bafera na pocetak fajla.*/
  if (write (fd, buffer1, strlen (buffer1)) != strlen (buffer1))
    error_fatal ("write error of buffer1");

  /* Vrsi se pomeranje za 100 pozicija od trenutne pozicije. */
  if (lseek (fd, 100, SEEK_CUR) < 0)
    error_fatal ("lseek error");
  
  /* Na novoj poziciji se ispisuje poruka iz drugog bafera. */
  if (write (fd, buffer2, strlen (buffer2)) != strlen (buffer2))
    error_fatal ("write error of buffer2");
  
  /* Zatvara se fajl deskriptor. */
  close (fd);

  return 0;
}
