#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

// Duzina svakog reda koji se ucitava je 6 bajtova
#define BUFF_SIZE 6

/* Funkcija ispisuje primljenu poruku kao i string koji opisuje nastali problem.
   Potom prekida izvrsavanje programa. */
void error_fatal (char *message){
  perror (message);
  exit (1);
}

int main(){
  int r_fd;
  int w_fd;
  int read_chars;
  char buffer[BUFF_SIZE];

  /* Otvara se fajl brojevi.txt samo za citanje. Pretpostavka je da fajl postoji. */
  if ( (r_fd = open ("brojevi.txt", O_RDONLY)) < 0)
    error_fatal ("open error for file brojevi.txt");

  /* Otvara se fajl a ako ne postoji kreira sa odgovarajucim pravima (o tome vise price kasnije). 
     Ukoliko fajl vec postoji njegova duzina se smanjuje na 0. */
  if ( (w_fd = open ("sortirani_brojevi.txt", O_WRONLY | O_CREAT | O_TRUNC, 0644)) < 0)
    error_fatal ("open error for file sortirani_brojevi.txt");

  /* Dok god uspeva da se ucita red, iz reda se cita pozicija broja u sortiranom nizu,
     vrsi se pozicioniranje na odgovarajucu poziciju u datoteci i u nju upisuje sortirani broj. */
  while ( (read_chars = read (r_fd, buffer, BUFF_SIZE)) == BUFF_SIZE){
    if (lseek (w_fd, (buffer[4]-'0')*4, SEEK_SET) < 0)
      error_fatal ("lseek error");
    buffer[3] = '\n';
    if (write (w_fd, buffer, 4) != 4)
      error_fatal ("write error");
  }
  if (read_chars < 0)
    error_fatal ("read error");

  /* Zatvaraju se fajl deskriptori. */
  close (r_fd);
  close (w_fd);

  return 0;
}
