#include <stdio.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <string.h>

#define BUFF_SIZE 1024

/* Funkcija ispisuje primljenu poruku kao i string koji opisuje nastali problem.
   Potom prekida izvrsavanje programa. */
void error_fatal (char *message){
  perror (message);
  exit (1);
}

int main(){
  int r_fd;
  int w_fd;
  int read_chars;
  char buffer[BUFF_SIZE];

  /* Otvara se fajl primera.txt samo za citanje. Pretpostavka je da fajl vec postoji.*/
  if ( (r_fd = open ("primera.txt", O_RDONLY)) < 0)
    error_fatal ("open error for file primera.txt");

  /* Otvara se fajl a ako ne postoji kreira sa odgovarajucim pravima (o tome vise price kasnije). 
     Ukoliko fajl vec postoji njegova duzina se smanjuje na 0. */
  if ( (w_fd = open ("tabele.txt", O_WRONLY | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP | S_IROTH)) < 0)
    error_fatal ("open error for file tabele.txt");

  /* Prepisuju se karakteri iz jedne datoteke u drugu. */
  while ( (read_chars = read (r_fd, buffer, sizeof (buffer))) > 0)
    if (write (w_fd, buffer, read_chars) != read_chars)
      error_fatal ("write error from primera.txt to tabele.txt");
  if (read_chars < 0)
    error_fatal ("read error in primera.txt");

  /* Zatvara se fajl deskriptor. */
  close (r_fd);

  /* Otvara se fajl calco.txt samo za citanje. Pretpostavka je da fajl vec postoji. */
  if ( (r_fd = open ("calco.txt", O_RDONLY)) < 0)
    error_fatal ("open error for file primera.txt");

  /* Prepisuju se karakteri iz jedne datoteke u drugu. */
  while ( (read_chars = read (r_fd, buffer, sizeof (buffer))) > 0)
    if (write (w_fd, buffer, read_chars) != read_chars)
      error_fatal ("write error from calco.txt to tabele.txt");
  if (read_chars < 0)
    error_fatal ("read error in primera.txt");

  /* Zatvaraju se fajl deskriptori. */
  close (r_fd);
  close (w_fd);

  return 0;
}
