#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

static void error_fatal (const char *message){
  perror (message);
  exit (EXIT_FAILURE);
}

int main(int argc, char **argv){
  int fd;
  int i;
  char file_name[128];
  char character;
  char step;
  int file_size;
  char buffer[1];

  if (argc < 4){
    fprintf (stderr,"./zameni_karakter file character step\n");
    exit (EXIT_FAILURE);
  }

  strcpy (file_name, argv[1]);
  character = argv[2][0];
  step = atoi (argv[3]);
  buffer[0] = character;

  // Otvaranje fajla za pisanje, pretpostavka je da postoji
  if ( (fd = open (file_name, O_WRONLY)) < 0)
    error_fatal ("open error");

  // Izracunavanje velicine fajla
  if ( (file_size = lseek (fd, 0, SEEK_END)) < 0)
    error_fatal ("lseek: determining file size error");

  // Vracanje na pocetak fajla
  if ( lseek (fd, 0, SEEK_SET) < 0)
    error_fatal ("lseek: returning to the beginning error");
  
  // Zamena slova karakterom koji je argument komandne linije; vodi se racuna da se ne izadje van fajla
  for (i=0; i*step < file_size; i++){
    if (lseek (fd, step-1, SEEK_CUR) < 0) // -1 because moving by one character is done in write
      error_fatal ("lseek: moving by step error");
	
    if ( write (fd, buffer, 1) != 1)
      error_fatal ("write error");
  }

  close (fd);
  
  return 0;
}

  
